﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Diagnostics;

namespace rigoltest1 {
    class Program {
        static void Main(string[] args)
        {
            var update = File.ReadAllBytes(@"C:\Users\Andreas\Downloads\Rigol\DS1000EUpdate\DS1000EUpdate.RGL");
            var flash = File.ReadAllBytes(@"C:\Users\Andreas\Downloads\Rigol\secondflash2patched.bin");
            bool lastdiff = false;
            int lastoffs = 0;
            int lastend = 0;
            int end = 1024 * 1024 * 4; // 4194304
            string hexof(byte[] buf, int start, int len)
            {
                return string.Join(":", buf.Skip(start).Take(len).Select(b => b.ToString("X2")));
            }
            void showdiff(int start, int len)
            {
                if(len <= 0x10) {
                    Console.WriteLine($"Diff at {start:X8} len {len:X8}  flash: {hexof(flash, start, len)}   rgl:{hexof(update, start + 0x15, len)}");
                } else {
                    Console.WriteLine($"Diff at {start:X8} len {len:X8}");
                    for(int i = 0; i < len; i += 0x10) {
                        int sublen = Math.Min(len - i, 0x10);
                        //Console.WriteLine($"{start + i:X8} flash: {hexof(flash, start + i, sublen)}   rgl:{hexof(update, start + i + 0x15, sublen)}");
                    }
                }
            }
            List<(int offset, byte data)> diffs = new List<(int offset, byte data)>();
            for (int i = 0; i < end; i++) {
                if(update[i + 0x15] != flash[i]) {
                    if(!lastdiff) {
                        lastdiff = true;
                        if(lastend == 0)
                            lastoffs = i;
                    }
                    
                } else {
                    if (lastdiff) {
                        lastend = i - 1;
                        lastdiff = false;
                    }
                    if(lastend > 0 && i - lastend > 100 && update[i+0x15] != 0xff) {
                        if (lastend == lastoffs) {
                            // Single byte diff
                            diffs.Add((lastoffs, update[lastoffs + 0x15]));
                        }
                        showdiff(lastoffs, lastend - lastoffs + 1);
                        lastend = 0;
                    }
                }
            }
            if (lastdiff) {
                showdiff(lastoffs, end - lastoffs);
            } else if(lastend > 0) {
                showdiff(lastoffs, lastend - lastoffs + 1);
            }
            int upper = 0;
            byte hibyte(int value) => (byte)((value >> 8) & 0xff);
            byte lobyte(int value) => (byte)(value & 0xff);
            string hexrecord(byte recordtype, int addr, byte[] data)
            {
                Debug.Assert(addr <= 0xffff);
                byte chk = (byte)-(recordtype + hibyte(addr) + lobyte(addr) + data.Length + data.Sum(b => b));
                return $":{data.Length:X2}{addr:X4}{recordtype:X2}{string.Join("", data.Select(b => b.ToString("X2")))}{chk:X2}";
            }
            using (var hex = new StreamWriter(@"C:\Users\Andreas\Downloads\Rigol\modify2.hex")) {
                int from = 0x3e0000;
                int to = 0x400000;
                byte[] data = new byte[16];
                for(int addr = from; addr < to; addr += 0x10) {
                    int newupper = addr >> 16;
                    int lower = addr & 0xffff;
                    if (newupper != upper) {
                        upper = newupper;
                        hex.WriteLine(hexrecord(4, 0, new[] { hibyte(upper), lobyte(upper) }));
                    }
                    Array.Copy(update, addr + 0x15, data, 0, data.Length);
                    hex.WriteLine(hexrecord(0, lower, data));
                }
                //foreach(var (addr, data) in diffs) {
                //    int newupper = addr >> 16;
                //    int lower = addr & 0xffff;
                //    if(newupper != upper) {
                //        upper = newupper;
                //        hex.WriteLine(hexrecord(4, 0, new[] { hibyte(upper), lobyte(upper)}));
                //    }
                //    hex.WriteLine(hexrecord(0, lower, new[] { data}));
                //}
                hex.WriteLine(hexrecord(1, 0, new byte[] { }));
            }
        }
    }
}
